#bunker
playsound minecraft:bgm.bunker master @s[scores={bgm=0,cutscene=..0}] 0 1000000 0 1000000000 1
scoreboard players set @s[scores={bgm=0,cutscene=..0}] bgm 3640
execute at @s[gamemode=adventure,scores={cutscene=..0,zpos=1481..}] run tp @s ~ ~ 14.8
execute at @s[scores={zpos=1200..1480,xpos=..-113700}] run tp @s ~266 ~1 ~
execute at @s[scores={zpos=1200..1480,xpos=-83400..}] run tp @s ~-266 ~1 ~


execute if score @s cutscene matches ..0 at @s[x=-1100,y=97,z=12.6,dx=266,dy=5,dz=2] unless score @s pov matches 0 run function nier:player/povset/x
execute if score @s cutscene matches ..0 at @s[x=-1100,y=98,z=7,dx=266,dy=5,dz=1.2] unless score @s pov matches 2 run function nier:player/povset/z
execute if score @s cutscene matches ..0 at @s[x=-908,y=97,z=-5,dx=13,dy=5,dz=2] unless score @s pov matches -1 run function nier:player/povset/w
execute if score @s cutscene matches ..0 at @s[x=-904,y=97,z=0,dx=5,dy=4,dz=9] unless score @s pov matches 2 run function nier:player/povset/z

#doors
execute at @s positioned ~ ~-1 ~ at @e[tag=door,distance=..3,limit=1,sort=arbitrary,tag=!open] run playsound minecraft:eff.door master @s ~ ~ ~ 1 0.9
execute at @s positioned ~ ~-1 ~ run tag @e[tag=door,distance=..3,limit=1,sort=arbitrary] add open
execute at @s positioned ~ ~2 ~ at @e[tag=door,distance=4..,limit=1,sort=nearest,tag=open] run playsound minecraft:eff.door master @s ~ ~ ~ 1 0.5
execute at @s positioned ~ ~2 ~ run tag @e[tag=door,distance=4..,limit=1,sort=nearest] remove open
data merge entity @e[name=door,tag=open,limit=1,sort=arbitrary] {Motion:[0.0,1.0,0.0]}

execute at @s run scoreboard players add @e[name=commanddoor,scores={cooldown=..12},distance=..3] cooldown 2
execute at @e[name=commanddoor,scores={cooldown=1}] run clone -910 97 10 -906 100 10 ~-2 ~ ~ replace
execute at @e[name=commanddoor,scores={cooldown=5}] run clone -914 97 10 -910 100 10 ~-2 ~ ~ replace
execute at @e[name=commanddoor,scores={cooldown=9}] run clone -919 97 10 -915 100 10 ~-2 ~ ~ replace

#elevator
execute if entity @e[name=elevatorcontrol,tag=!up,scores={cooldown=0}] if entity @s[scores={ypos=9500..10000}] run tag @e[name=elevatorcontrol] add up
execute if entity @e[name=elevatorcontrol,tag=up,scores={cooldown=0}] if entity @s[scores={ypos=8500..9000}] run tag @e[name=elevatorcontrol] remove up
execute if entity @e[name=elevatorcontrol,tag=!up,scores={cooldown=0}] at @e[name=elevatordown] as @a[distance=..1] run tag @e[name=elevatorcontrol] add up
execute if entity @e[name=elevatorcontrol,tag=up,scores={cooldown=0}] at @e[name=elevatorup] as @a[distance=..1] run tag @e[name=elevatorcontrol] remove up

execute if entity @e[name=elevator,x=-903,y=86.3,z=-11,dx=3,dy=10,dz=4] run scoreboard players set @e[name=elevatorcontrol,tag=!up] cooldown 40
execute if entity @e[name=elevator,x=-903,y=84.1,z=-11,dx=3,dy=11,dz=4] run scoreboard players set @e[name=elevatorcontrol,tag=up] cooldown 40
execute if entity @e[name=elevatorcontrol,tag=!up] as @e[name=elevator,x=-903,y=86.3,z=-11,dx=3,dy=10,dz=4] at @s run tp @s ~ ~-0.1 ~
execute if entity @e[name=elevatorcontrol,tag=up] as @e[name=elevator,x=-903,y=84.1,z=-11,dx=3,dy=11,dz=4] at @s run tp @s ~ ~0.1 ~
execute if entity @e[name=elevatorcontrol,tag=up] at @e[name=elevator] run effect give @s[distance=..1] minecraft:levitation 1 1 true
execute if entity @e[name=elevatorcontrol,tag=up] at @e[name=elevator] at @s[distance=..0.9] run tp @s ~ ~0.1 ~

execute if block -902 97 -8 minecraft:oak_trapdoor[open=false] if entity @e[name=elevatorcontrol,scores={cooldown=38..}] run clone -900 85 -4 -900 85 -5 -902 97 -8
execute if block -902 87 -12 minecraft:oak_trapdoor[open=false] if entity @e[name=elevatorcontrol,scores={cooldown=38..}] run clone -900 85 -4 -900 85 -5 -902 87 -12
execute if entity @e[name=elevatorcontrol,scores={cooldown=..35},tag=up] run effect clear @s[scores={cutscene=..0}] minecraft:levitation
execute if block -902 97 -8 minecraft:oak_trapdoor[open=true] if entity @e[name=elevatorcontrol,scores={cooldown=..35},tag=up] run clone -904 85 -4 -904 85 -5 -902 97 -8
execute if block -902 87 -12 minecraft:oak_trapdoor[open=true] if entity @e[name=elevatorcontrol,scores={cooldown=..35},tag=!up] run clone -904 85 -4 -904 85 -5 -902 87 -12

#cutscenes
execute positioned -973 97 12 if entity @s[scores={cutscene=..0},distance=..0.6] run function nier:world/cutscenes/start/bunkerhangerup
execute positioned -974 110 8 if entity @s[scores={cutscene=..0},distance=..0.6] run function nier:world/cutscenes/start/bunkerhangerdown
execute positioned -1045 97 12 if entity @s[scores={cutscene=..0},distance=..0.6] run function nier:world/cutscenes/start/bunkerterminalup
execute positioned -1046 110 8 if entity @s[scores={cutscene=..0},distance=..0.6] run function nier:world/cutscenes/start/bunkerterminaldown
execute positioned -973.5 110 -20.5 if entity @s[scores={cutscene=..0,ch=0},distance=..0.6] run function nier:world/cutscenes/start/liftoff

#inv
execute as @e[tag=pod,scores={cooldown=80}] run data merge entity @s {CustomNameVisible:0b,CustomName:""}
execute if entity @e[tag=pod,scores={cooldown=10}] run tellraw @s {"text":"[Pod 018] Proposal: YoRHa unit 7E should report to the Commander.","color":"white"}
execute at @s as @e[tag=accesspoint,distance=..2.4] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"Access Point\"}"}
execute at @s as @e[tag=accesspoint,distance=2.5..] run data merge entity @s {CustomNameVisible:0b,CustomName:""}
execute at @s as @e[tag=shop,distance=..2.4] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"Shop\"}"}
execute at @s as @e[tag=shop,distance=2.5..] run data merge entity @s {CustomNameVisible:0b,CustomName:""}

#dialogue
execute at @s as @e[tag=npc,distance=5..] run scoreboard players set @s ch 0
execute at @s[scores={rm=1}] run scoreboard players add @e[tag=npc,distance=..2] ch 1
execute at @s[scores={rm=1}] if entity @e[tag=npc,distance=..2] run playsound minecraft:eff.dwi master @s ~ ~ ~

#commander
execute as @e[tag=commander,scores={ch=0}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"Commander\"}"}
execute at @e[tag=commander,scores={ch=10..}] run scoreboard players set @s ch 0
execute at @e[tag=commander,scores={ch=7}] as @s[scores={rm=1}] run scoreboard players set @s mail 1
execute if score @s rm matches 1.. if score @e[tag=commander,limit=1] ch matches 7 at @e[tag=2b] run kill @e[distance=..2]
execute if score @s rm matches 1.. if score @e[tag=commander,limit=1] ch matches 7 run summon zombie_pigman -952.7 98 4.5 {Silent:1b,Invulnerable:1b,NoAI:1b,Rotation:[90F,0F],Tags:["2b","npc"]}
execute if score @s rm matches 1.. if score @e[tag=commander,limit=1] ch matches 7 run advancement grant @s only nier:nier/mail
execute unless score @e[tag=commander,limit=1] ch matches 7 run advancement revoke @s[scores={ch=0}] only nier:nier/mail

execute unless score @s ch matches 0 as @e[tag=commander,scores={ch=1}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"I see you've finished maintenance, 7E.\"}"}
execute unless score @s ch matches 0 as @e[tag=commander,scores={ch=2}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"There's no time to rest, I have another mission for you.\"}"}
execute unless score @s ch matches 0 as @e[tag=commander,scores={ch=3}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"We picked up signals of a Goliath-Class Machine Lifeform...\"}"}
execute unless score @s ch matches 0 as @e[tag=commander,scores={ch=4}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"...in the Abandoned Factory on the surface of the earth.\"}"}
execute unless score @s ch matches 0 as @e[tag=commander,scores={ch=5}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"You are to descend with a squadron of YoRHa members...\"}"}
execute unless score @s ch matches 0 as @e[tag=commander,scores={ch=6}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"...down to the surface to investigate and gather intel.\"}"}
execute as @e[tag=commander,scores={ch=7}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"I've sent the mission details to your mailbox.\"}"}
execute as @e[tag=commander,scores={ch=8}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"Please review them near an access point before you head to the hangar.\"}"}
execute as @e[tag=commander,scores={ch=9}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"Glory, to Mankind.\"}"}
execute as @e[tag=commander,scores={ch=10}] run data merge entity @s {CustomNameVisible:0b,CustomName:""}
execute as @e[tag=commander,scores={ch=11..}] run scoreboard players set @s ch 1
execute if score @s ch matches 0 as @e[tag=commander,scores={ch=1}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"Shouldn't you be heading off on a mission?\"}"}
execute if score @s ch matches 0 as @e[tag=commander,scores={ch=2}] run data merge entity @s {CustomNameVisible:0b,CustomName:""}
execute if score @s ch matches 0 as @e[tag=commander,scores={ch=3}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"Further delay is detrimental to the operation.\"}"}
execute if score @s ch matches 0 as @e[tag=commander,scores={ch=4}] run data merge entity @s {CustomNameVisible:0b,CustomName:""}
execute if score @s ch matches 0 as @e[tag=commander,scores={ch=5}] run scoreboard players set @s ch 1
execute as @e[tag=commander] unless entity @p[scores={pov=-1}] run data merge entity @s {CustomNameVisible:0b,CustomName:""}

#operator by window
execute as @e[tag=operator_window,scores={ch=0}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"Operator\"}"}
execute at @s unless entity @s[scores={ch=0..}] as @e[tag=operator_window,distance=..2] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"Right Click to Interact\"}"}
execute as @e[tag=operator_window,scores={ch=4..}] run scoreboard players set @s ch 1
execute unless score @s ch matches 0 as @e[tag=operator_window,scores={ch=1}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"I think the Commander wishes to see you.\"}"}
execute unless score @s ch matches 0 as @e[tag=operator_window,scores={ch=2}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"I wouldn't tarry long if I were you.\"}"}
execute unless score @s ch matches 0 as @e[tag=operator_window,scores={ch=3}] run data merge entity @s {CustomNameVisible:0b,CustomName:""}
execute if score @s ch matches 0 as @e[tag=operator_window,scores={ch=1}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"I heard you have a new mission.\"}"}
execute if score @s ch matches 0 as @e[tag=operator_window,scores={ch=2}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"You'd best check your mail at an access point to learn the specifics.\"}"}
execute if score @s ch matches 0 as @e[tag=operator_window,scores={ch=3}] run data merge entity @s {CustomNameVisible:0b,CustomName:""}
execute as @e[tag=operator_window] unless entity @p[scores={pov=0}] run data merge entity @s {CustomNameVisible:0b,CustomName:""}

#5O
execute as @e[tag=operator_5o,scores={ch=0}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"Operator 5O\"}"}
execute unless score @s ch matches 0 as @e[tag=operator_5o,scores={ch=3..}] run scoreboard players set @s ch 1
execute if score @s ch matches 0 as @e[tag=operator_5o,scores={ch=5..}] run scoreboard players set @s ch 1
execute unless score @s ch matches 0 as @e[tag=operator_5o,scores={ch=1}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"Hey there, 7E, how's it going?\"}"}
execute unless score @s ch matches 0 as @e[tag=operator_5o,scores={ch=2}] run data merge entity @s {CustomNameVisible:0b,CustomName:""}
execute if score @s ch matches 0 as @e[tag=operator_5o,scores={ch=1}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"I heard you're heading down to the surface.\"}"}
execute if score @s ch matches 0 as @e[tag=operator_5o,scores={ch=2}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"I've always wanted to try out one of those flight units.\"}"}
execute if score @s ch matches 0 as @e[tag=operator_5o,scores={ch=3}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"Have fun on your mission!\"}"}
execute if score @s ch matches 0 as @e[tag=operator_5o,scores={ch=4}] run data merge entity @s {CustomNameVisible:0b,CustomName:""}
execute as @e[tag=operator_5o] at @s unless entity @p[scores={pov=-1},distance=..3] run data merge entity @s {CustomNameVisible:0b,CustomName:""}

#2B
execute as @e[tag=2b,scores={ch=0}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"2B\"}"}
execute unless entity @s[scores={ch=0..}] as @e[tag=2b,scores={ch=3..}] run scoreboard players set @s ch 1
execute if score @s ch matches 0 as @e[tag=2b,scores={ch=8..}] run scoreboard players set @s ch 6
execute unless entity @s[scores={ch=0..}] as @e[tag=2b,scores={ch=1}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"...\"}"}
execute unless entity @s[scores={ch=0..}] as @e[tag=2b,scores={ch=2}] run data merge entity @s {CustomNameVisible:0b,CustomName:""}
execute if score @s ch matches 0 as @e[tag=2b,scores={ch=1}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"So, you'll be participating in the operation as well.\"}"}
execute if score @s ch matches 0 as @e[tag=2b,scores={ch=2}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"Unlike you, I'm a type-B combat model.\"}"}
execute if score @s ch matches 0 as @e[tag=2b,scores={ch=3}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"My only concern is the successful completion of the mission objective.\"}"}
execute if score @s ch matches 0 as @e[tag=2b,scores={ch=4}] run data merge entity @s {CustomNameVisible:0b,CustomName:""}
execute if score @s ch matches 0 as @e[tag=2b,scores={ch=5}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"Glory, to Mankind\"}"}
execute if score @s ch matches 0 as @e[tag=2b,scores={ch=6}] run data merge entity @s {CustomNameVisible:0b,CustomName:""}
execute if score @s ch matches 0 as @e[tag=2b,scores={ch=7}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"...\"}"}
execute as @e[tag=2b] at @s unless entity @p[scores={pov=2},distance=..10] run data merge entity @s {CustomNameVisible:0b,CustomName:""}

#operator in terminal room
execute as @e[tag=operator_terminal,scores={ch=0}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"Operator\"}"}
execute as @e[tag=operator_terminal,scores={ch=5..}] run scoreboard players set @s ch 1
execute as @e[tag=operator_terminal,scores={ch=1}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"How are you feeling after maintenance?\"}"}
execute as @e[tag=operator_terminal,scores={ch=2}] run data merge entity @s {CustomNameVisible:0b,CustomName:""}
execute as @e[tag=operator_terminal,scores={ch=3}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"I hope you're doing well.\"}"}
execute as @e[tag=operator_terminal,scores={ch=4}] run data merge entity @s {CustomNameVisible:0b,CustomName:""}
execute as @e[tag=operator_terminal] at @s unless entity @p[scores={pov=2},distance=..20] run data merge entity @s {CustomNameVisible:0b,CustomName:""}

#operator in hangar
execute as @e[tag=operator_hangar,scores={ch=0}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"Operator\"}"}
execute as @e[tag=operator_hangar,scores={ch=7..}] run scoreboard players set @s ch 1
execute as @e[tag=operator_hangar,scores={ch=1}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"These Flight Units are very expensive to make, you know?\"}"}
execute as @e[tag=operator_hangar,scores={ch=2}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"We don't have a way to mass produce them yet.\"}"}
execute as @e[tag=operator_hangar,scores={ch=3}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"Try not to damage it too much.\"}"}
execute as @e[tag=operator_hangar,scores={ch=4}] run data merge entity @s {CustomNameVisible:0b,CustomName:""}
execute as @e[tag=operator_hangar,scores={ch=5}] run data merge entity @s {CustomNameVisible:1b,CustomName:"{\"text\":\"You're not the ones having to fix them up.\"}"}
execute as @e[tag=operator_hangar,scores={ch=6}] run data merge entity @s {CustomNameVisible:0b,CustomName:""}
execute as @e[tag=operator_hangar] at @s unless entity @p[scores={pov=2},distance=..20] run data merge entity @s {CustomNameVisible:0b,CustomName:""}